require File.expand_path(File.dirname(__FILE__) + '/spec_helper')

include NorthPoleWrapper

describe NorthPoleWrapper do
  it "shold work" do
    API_KEY.should == 'guest@northpole.ro'

    User.klass.should == 'user'

    module Foo
      module Bar
        class Dar < Resource
        end
      end
    end

    Foo::Bar::Dar.klass.should == 'dar'

    class Hello < Resource
    end

    Hello.klass.should == 'hello'
  end 

  it "should create" do
    body = Storage.create('api_key' => API_KEY, 'secret' => SECRET,
                          'foo' => 'bar').body
    body.class.should == String
    json = JSON.parse(body)
  end

  it "should find" do
    body = Storage.create('api_key' => API_KEY, 'secret' => SECRET,
                          'foo' => 'bar').body
    body.class.should == String
    json = JSON.parse(body)

    body2 = Storage.find('api_key' => API_KEY, 'secret' => SECRET,
                         '_id' => json['_id']).body
    json2 = JSON.parse(body2)
    json2.count.should > 0
    json2[0]['foo'].should == 'bar'
  end

  it "should update" do
    body = Storage.create('api_key' => API_KEY, 'secret' => SECRET,
                          'foo' => 'bar').body
    body.class.should == String
    json = JSON.parse(body)

    body2 = Storage.update('api_key' => API_KEY, 'secret' => SECRET,
                           '_id' => json['_id'], 'foo' => 'haha').body
    json2 = JSON.parse(body2)
    json2['_id'].should == json['_id']


    body3 = Storage.find('api_key' => API_KEY, 'secret' => SECRET,
                         '_id' => json['_id']).body
    json3 = JSON.parse(body3)
    json3.count.should > 0
    json3[0]['foo'].should == 'haha'
  end

  it "should delete" do
    body = Storage.create('api_key' => API_KEY, 'secret' => SECRET,
                          'foo' => 'bar').body
    body.class.should == String
    json = JSON.parse(body)

    Storage.destroy('api_key' => API_KEY, 'secret' => SECRET,
                   '_id' => json['_id'])

    body2 = Storage.find('api_key' => API_KEY, 'secret' => SECRET,
                         '_id' => json['_id']).body
    json2 = JSON.parse(body2)
    json2.count.should == 0
  end
end
